<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/25/2003 *
 * ===============                              Last change: 11/29/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : functions.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Many non-MySQL functions (also file access)      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Viele Nicht-MySQL-Funktionen (auch Dateizugriff) *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Check if our config file is writeable or not
function is_INCWritable($inc) {
	$fp = @fopen(PATH."inc/".$inc.".php", 'a');
	if ($inc == "dummy") {
		// Remove dummy file
		@fclose($fp);
		return @unlink(PATH."inc/dummy.php");
	} else {
		// Close all other files
		return @fclose($fp);
	}
}

// Open a table (you may want to add some header stuff here)
function OPEN_TABLE($PERCENT = "", $CLASS = "", $ALIGN="left", $VALIGN="", $td_only=false) {
	global $table_cnt;
	// Count tables so we can generate CSS classes for every table... :-)
	if (empty($CLASS)) {
		// Class is empty so count one up and create a class
		$table_cnt++; $CLASS = "class".$table_cnt;
	}
	$OUT = "<TABLE border=\"0\" cellspacing=\"0\" cellpadding=\"0\"";

	// Shall I add the classes to TABLE and TD or only to TD?
	if (!$td_only) $OUT .= " class=\"".$CLASS."\"";

	// Width is given
	if (!empty($PERCENT)) $OUT .= " width=\"".$PERCENT."\"";

	// Horizonal align
	if (!empty($ALIGN)) $OUT .=" align=\"".$ALIGN."\"";

	// Vertical align is given
	if (!empty($VALIGN))  $OUT .= " valign=\"".$VALIGN."\"";
	$OUT .= ">\n<TR>\n<TD";
	if (!empty($ALIGN)) $OUT .=" align=\"".$ALIGN."\"";
	$OUT .= " class=\"".$CLASS."\">";
	OUTPUT_HTML($OUT);
}

// Close a table (you may want to add some footer stuff here)
function CLOSE_TABLE($ADD="") {
	OUTPUT_HTML("  </TD>\n</TR>");
	if (!empty($ADD)) OUTPUT_HTML($ADD);
	OUTPUT_HTML("</TABLE>");
}

// Output HTML code directly or "render" it. You addionally switch the new-line character off
function OUTPUT_HTML($HTML, $NEW_LINE = true) {
	// Some global variables
	global $OUTPUT, $footer, $CSS;

	// Do we have HTML-Code here?
	if (!empty($HTML)) {
		// Yes, so we handle it as you have configured
		switch (OUTPUT_MODE)
		{
		case "render":
			// That's why you don't need any \n at the end of your HTML code... :-)
			if (_OB_CACHING == "on") {
				// Output into PHP's internal buffer
				OUTPUT_RAW($HTML);

				// That's why you don't need any \n at the end of your HTML code... :-)
				if ($NEW_LINE) echo "\n";
			} else {
				// Render mode for old or lame servers...
				$OUTPUT .= $HTML;

				// That's why you don't need any \n at the end of your HTML code... :-)
				if ($NEW_LINE) $OUTPUT .= "\n";
			}
			break;

		case "direct":
			// If we are switching from render to direct output rendered code
			if ((!empty($OUTPUT)) && (_OB_CACHING != "on")) { OUTPUT_RAW($OUTPUT); $OUTPUT = ""; }

			// The same as above... ^
			OUTPUT_RAW($HTML);
			if ($NEW_LINE) echo "\n";
			break;

		default:
			// Huh, something goes wrong or maybe you have edited config.php ???
			die ("<STRONG>".FATAL_ERROR.":</STRONG> ".LANG_NO_RENDER_DIRECT);
			break;
		}
	} elseif ((_OB_CACHING == "on") && ($footer == 1)) {
		// Output cached HTML code
		$OUTPUT = ob_get_contents();

		// Clear output buffer for later output
		ob_end_clean();

		if ((EXT_IS_ACTIVE("rewrite", true)) && (function_exists('REWRITE_LINKS')) && ($CSS != "1") && ($CSS != "-1")) {
			$OUTPUT = REWRITE_LINKS($OUTPUT);
		}

		// Compile and run finished rendered HTML code
		while (strpos($OUTPUT, '{!') > 0) {
			$eval = "\$OUTPUT = \"" . COMPILE_CODE(addslashes($OUTPUT)) . "\";";
			eval($eval);
		}

		// Output code here, DO NOT REMOVE! ;-)
		OUTPUT_RAW($OUTPUT);
	} elseif ((OUTPUT_MODE == "render") && (!empty($OUTPUT))) {
		// Rewrite links when rewrite extension is active
		if ((EXT_IS_ACTIVE("rewrite", true)) && (function_exists('REWRITE_LINKS')) && ($CSS != "1") && ($CSS != "-1")) {
			$OUTPUT = REWRITE_LINKS($OUTPUT);
		}

		// Compile and run finished rendered HTML code
		while (strpos($OUTPUT, '{!') > 0) {
			$eval = "\$OUTPUT = \"" . COMPILE_CODE(addslashes($OUTPUT)) . "\";";
			eval($eval);
		}

		// Output code here, DO NOT REMOVE! ;-)
		OUTPUT_RAW($OUTPUT);
	}
}

// Output the raw HTML code
function OUTPUT_RAW ($HTML) {
	// Output stripped HTML code to avoid broken JavaScript code, etc.
	echo stripslashes($HTML);

	// Flush the output if only _OB_CACHING is not "on"
	if (_OB_CACHING != "on") {
		// Flush it
		flush();
	}
}

// Add a fatal error message to the queue array
function ADD_FATAL ($message, $extra="") {
	global $FATAL;
	if (empty($extra)) {
		// Regular text message to add to $FATAL
		$FATAL[] = $message;
	} else {
		// $message is text with a mask plus extras to insert into the text
		$FATAL[] = sprintf($message, $extra);
	}
}

// Load a template file and return it's content (only it's name; do not use ' or ")
function LOAD_TEMPLATE($template, $return=false, $content="") {
	// Add more variables which you want to use in your template files
	global $DATA, $_CONFIG, $username;

	// Count the template load
	if (!isset($_CONFIG['num_templates'])) $_CONFIG['num_templates'] = 0;
	$_CONFIG['num_templates']++;

	// Init some data
	$ACTION = SQL_ESCAPE($GLOBALS['action']);
	$WHAT = SQL_ESCAPE($GLOBALS['what']);
	$ret = "";
	if (empty($GLOBALS['refid'])) $GLOBALS['refid'] = 0;
	$REFID = $GLOBALS['refid'];

	if ($template == "member_support_form") {
		// Support request of a member
		$result = SQL_QUERY_ESC("SELECT sex, surname, family FROM "._MYSQL_PREFIX."_user_data WHERE userid=%d LIMIT 1",
		 array($GLOBALS['userid']), __FILE__, __LINE__);
		list($sex, $surname, $family) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);
		$salut = TRANSLATE_SEX($sex);
	}

	// Generate date/time string
	$date_time = MAKE_DATETIME(time(), "1");

	// Base directory
	$BASE = PATH."templates/".GET_LANGUAGE()."/html/";
	$MODE = "";

	// Check for admin/guest/member templates
	if (strpos($template, "admin_") > -1) {
		// Admin template found
		$MODE = "admin/";
	} elseif (strpos($template, "guest_") > -1) {
		// Guest template found
		$MODE = "guest/";
	} elseif (strpos($template, "member_") > -1) {
		// Member template found
		$MODE = "member/";
	} elseif (strpos($template, "install_") > -1) {
		// Installation template found
		$MODE = "install/";
	} elseif (strpos($template, "ext_") > -1) {
		// Extension template found
		$MODE = "ext/";
	} elseif (strpos($template, "la_") > -1) {
		// "Logical-area" template found
		$MODE = "la/";
	} else {
		// Test for extension
		$test = substr($template, 0, strpos($template, "_"));
		if (EXT_IS_ACTIVE($test)) {
			// Set extra path to extension's name
			$MODE = $test."/";
		}
	}

	////////////////////////
	// Generate file name //
	////////////////////////
	$file = $BASE.$MODE.$template.".tpl";

	if ((!empty($GLOBALS['what'])) && ((strpos($template, "_header") > 0) || (strpos($template, "_footer") > 0)) && (($MODE == "guest/") || ($MODE == "member/") || ($MODE == "admin/"))) {
		// Select what depended header/footer template file for admin/guest/member area
		$file2 = sprintf("%s%s%s_%s.tpl",
			$BASE,
			$MODE,
			$template,
			SQL_ESCAPE($GLOBALS['what'])
		);

		// Probe for it...
		if (file_exists($file2)) $file = $file2;

		// Remove variable from memory
		unset($file2);
	}

	// Does the special template exists?
	if ((!file_exists($file)) || (!is_readable($file))) {
		// Reset to default template
		$file = $BASE.$template.".tpl";
	}

	// Now does the final template exists?
	if ((file_exists($file)) && (is_readable($file))) {
		// The local file does exists so we load it. :)
		$tmpl_file = implode("", file($file));

		// Replace ' to our own chars to preventing them being quoted
		while (strpos($tmpl_file, "\'") !== false) { $tmpl_file = str_replace("\'", '{QUOT}', $tmpl_file); }

		// Do we have to compile the code?
		if ((strpos($tmpl_file, "\$") !== false) || (strpos($tmpl_file, '{--') !== false) || (strpos($tmpl_file, '--}') > 0)) {
			// Okay, compile it!
			$tmpl_file = "\$ret=\"" . COMPILE_CODE(addslashes($tmpl_file)) . "\";";
			eval($tmpl_file);
		} else {
			// Simply return loaded code
			$ret = $tmpl_file;
		}

		// Add surrounding HTML comments to help finding bugs faster
		$ret = "<!-- Template ".$template." - Start -->\n".$ret."<!-- Template ".$template." - End -->\n";
	} elseif ((IS_ADMIN()) || ((isBooleanConstantAndTrue('mxchange_installing')) && (!isBooleanConstantAndTrue('mxchange_installed')))) {
		// Only admins shall see this warning or when installation mode is active
		$ret = "<br /><SPAN class=\"guest_failed\">".TEMPLATE_404."</SPAN><br />
(".basename($file).")<br />
<br />
".TEMPLATE_CONTENT."
<PRE>".print_r($content, true)."</PRE>
".TEMPLATE_DATA."
<PRE>".print_r($DATA, true)."</PRE>
<br /><br />";
	}

	// Do we have some content to output or return?
	if (!empty($ret)) {
		// Not empty so let's put it out! ;)
		if ($return) {
			// Return the HTML code
			return $ret;
		} else {
			// Output direct
			OUTPUT_HTML($ret);
		}
	} elseif (isBooleanConstantAndTrue('DEBUG_MODE')) {
		// Warning, empty output!
		return "E:".$template."<br />\n";
	}
}

// Send mail out to an email address
function SEND_EMAIL($TO, $SUBJECT, $MSG, $HTML='N', $FROM="") {
	// Compile subject line (for POINTS constant etc.)
	$eval = "\$SUBJECT = \"" . COMPILE_CODE(addslashes($SUBJECT)) . "\";";
	eval($eval);
	$SUBJECT = html_entity_decode($SUBJECT);

	// Set from header
	if (!eregi("@", $TO)) {
		// Value detected, load email from database
		if (EXT_IS_ACTIVE("msg")) {
			ADD_MESSAGE_TO_BOX($TO, $SUBJECT, $MSG, $HTML);
			return;
		} else {
			$result_email = SQL_QUERY_ESC("SELECT email FROM "._MYSQL_PREFIX."_user_data WHERE userid=%d LIMIT 1", array(bigintval($TO)), __FILE__, __LINE__);
			list($TO) = SQL_FETCHROW($result_email);
			SQL_FREERESULT($result_email);
		}
	}

	// Not in PHPMailer-Mode
	if (!CHECK_PHPMAILER_USAGE()) {
		if (empty($FROM)) {
			// Load email header template
			$FROM = LOAD_EMAIL_TEMPLATE("header");
		} else {
			// Append header
			$FROM .= LOAD_EMAIL_TEMPLATE("header");
		}
	} elseif (isBooleanConstantAndTrue('DEBUG_MODE')) {
		if (empty($FROM)) {
			// Load email header template
			$FROM = LOAD_EMAIL_TEMPLATE("header");
		} else {
			// Append header
			$FROM .= LOAD_EMAIL_TEMPLATE("header");
		}
	}

	// Fix HTML parameter (default is no!)
	if (empty($HTML)) $HTML = 'N';
	if (isBooleanConstantAndTrue('DEBUG_MODE')) {
		// In debug mode we want to display the mail instead of sending it away so we can debug this part
		echo "<PRE>
".htmlentities(trim($FROM))."
To      : ".$TO."
Subject : ".$SUBJECT."
Message : ".$MSG."
</PRE>\n";
	} elseif (($HTML == 'Y') && (EXT_IS_ACTIVE("html_mail", true))) {
		// Send mail as HTML away
		SEND_HTML_EMAIL($TO, $SUBJECT, $MSG, $FROM);
	} elseif (!empty($TO)) {
		// Compile email
		$TO = COMPILE_CODE($TO);

		// Send Mail away
		SEND_RAW_EMAIL($TO, COMPILE_CODE($SUBJECT), COMPILE_CODE($MSG), $FROM);
	} elseif ($HTML == 'N') {
		// Problem found!
		SEND_RAW_EMAIL(WEBMASTER, COMPILE_CODE($SUBJECT), COMPILE_CODE($MSG), $FROM);
	}
}

// Check if legacy or PHPMailer command
// @private
function CHECK_PHPMAILER_USAGE() {
	return ((defined('SMTP_HOSTNAME')) && (defined('SMTP_USER')) && (defined('SMTP_PASSWORD')) && (SMTP_HOSTNAME != "") && (SMTP_USER != ""));
}

/*
 * Send out a raw email with PHPMailer class or legacy mail() command
 */
function SEND_RAW_EMAIL ($to, $subject, $msg, $from) {
	// Shall we use PHPMailer class or legacy mode?
	if (CHECK_PHPMAILER_USAGE()) {
		// Use PHPMailer class with SMTP enabled
		require_once(PATH."inc/phpmailer/class.phpmailer.php");
		require_once(PATH."inc/phpmailer/class.smtp.php");

		// get new instance
		$mail = new PHPMailer();
		$mail->PluginDir  = PATH."inc/phpmailer/";

		$mail->IsSMTP();
		$mail->SMTPAuth   = true;
		$mail->Host       = SMTP_HOSTNAME;
		$mail->Port       = 25;
		$mail->Username   = SMTP_USER;
		$mail->Password   = SMTP_PASSWORD;
		$mail->From       = $from;
		$mail->FromName   = MAIN_TITLE;
		$mail->Subject    = $subject;
		if ((EXT_IS_ACTIVE("html_mail")) && (strip_tags($msg) != $msg)) {
			$mail->Body       = $msg;
			$mail->AltBody    = "Your mail program required HTML support to read this mail!";
			$mail->WordWrap   = 70;
			$mail->IsHTML(true);
		} else {
			$mail->Body       = $msg;
		}
		$mail->AddAddress($to, "");
		$mail->AddReplyTo(WEBMASTER,MAIN_TITLE);
		$mail->AddCustomHeader("Errors-To:".WEBMASTER);
		$mail->AddCustomHeader("X-Loop:".WEBMASTER);
		$mail->Send();
	} else {
		// Use legacy mail() command
		@mail($to, $subject, $msg, $from);
	}
}
//

// Generate a password in a specified length or use default password length
function GEN_PASS($LEN = 0) {
	global $_CONFIG;
	if ($LEN == 0) $LEN = $_CONFIG['pass_len'];

	// Initialize array with all allowed chars
	$ABC = explode(",", "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z,0,1,2,3,4,5,6,7,8,9,-,+,_,/");

	// Initialize randomizer
	mt_srand((double) microtime() * 1000000);

	// Start creating password
	$PASS = "";
	for ($i = 0; $i < $LEN; $i++) {
		$PASS .= $ABC[mt_rand(0, sizeof($ABC) -1)];
	}

	// When the size is below 40 we can also add additional security by scrambling it
	if (strlen($PASS) <= 40) {
		// Also scramble the password
		$PASS = scrambleString($PASS);
	}

	// Return the password
	return $PASS;
}
//
function MAKE_DATETIME($time, $mode="0")
{
	if ($time == 0) {
		// Never happend
		return NEVER_HAPPENED;
	} else {
		// Filter out numbers
		$time = bigintval($time);
	}

	switch (GET_LANGUAGE())
	{
	case "de": // German date / time format
		switch ($mode)
		{
			case "0": $ret = date("d.m.Y \u\m H:i \U\h\\r", $time); break;
			case "1": $ret = strtolower(date("d.m.Y - H:i", $time)); break;
			case "2": $ret = date("d.m.Y|H:i", $time); break;
			case "3": $ret = date("d.m.Y", $time); break;
		}
		break;

	default:	// Default is the US date / time format!
		switch ($mode)
		{
			case "0": $ret = date("r", $time); break;
			case "1": $ret = date("Y-m-d - g:i A", $time); break;
			case "2": $ret = date("y-m-d|H:i", $time); break;
			case "3": $ret = date("y-m-d", $time); break;
		}
	}
	return $ret;
}

// Translates the american decimal dot into a german comma
function TRANSLATE_COMMA($dotted, $cut=true)
{
	global $_CONFIG;
	// Default is 3 you can change this in admin area "Misc -> Misc Options"
	if (empty($_CONFIG['max_comma'])) $_CONFIG['max_comma'] = "3";
	if (!ereg("\.", $dotted)) $dotted .= ".".str_repeat("0", $_CONFIG['max_comma']);
	if ($cut) {
		// Remove trailing zeros
		$dot = str_replace(".", "x", $dotted);
		while(substr($dot, -1, 1) == "0") {
			$dot = substr($dot, 0, -1);
		}

		if (substr($dot, -1, 1) == "x") {
			// Last char is the 'x'
			$dotted = substr($dot, 0, -1);
		} else {
			// Last char is a number
			$dotted = str_replace("x", ".", $dot);
		}
	}

	// Translate it now
	switch (GET_LANGUAGE()) {
	case "de":
		$pos = strpos($dotted, ".");
		if ($pos > 0) {
			if ($cut) {
				// Cut x numbers behind comma
				$dotted = str_replace(".", ",", substr($dotted, 0, ($pos + $_CONFIG['max_comma'] + 1)));
			} else {
				// Replace comma with dot
				$dotted = str_replace(".", ",", $dotted);
			}
		} elseif (!$cut) {
			if (empty($pos)) {
				$dotted = "0,".str_repeat("0", $_CONFIG['max_comma']);
			} else {
				$dotted .= ",".str_repeat("0", $_CONFIG['max_comma']);
			}
		}
		break;

	default:
		if (!$cut) {
			if ($pos > 0) {
				$dotted = substr($dotted, 0, ($pos + $_CONFIG['max_comma'] + 1));
			} else {
				$dotted .= ".".str_repeat("0", $_CONFIG['max_comma']);
			}
		}
		break;
	}
	return $dotted;
}

//
function DEREFERER($URL) {
	$URL = URL."/modules.php?module=loader&amp;url=".urlencode(base64_encode(COMPILE_CODE($URL)));
	return $URL;
}

//
function TRANSLATE_SEX($sex) {
	switch ($sex)
	{
		case "M": $ret = SEX_M; break;
		case "F": $ret = SEX_F; break;
		case "C": $ret = SEX_C; break;
		default : $ret = $sex; break;
	}
	return $ret;
}
//
function GET_POOL_TYPE($PT)
{
	switch ($PT)
	{
		case "TEMP"   : $ret = POOL_TEMP;    break;
		case "SEND"   : $ret = POOL_SEND;    break;
		case "NEW"    : $ret = POOL_NEW;     break;
		case "ADMIN"  : $ret = POOL_ADMIN;   break;
		case "ACTIVE" : $ret = POOL_ACTIVE;  break;
		case "DELETED": $ret = POOL_DELETED; break;
		default       : $ret = POOL_UNKNOWN." (".$PT.")"; break;
	}
	return $ret;
}
//
function FRAMETESTER($URL)
{
	global $_SERVER;
	$URL = URL."/modules.php?module=frametester&amp;url=".urlencode(base64_encode(COMPILE_CODE($URL)));
	return $URL;
}
//
function SELECTION_COUNT($array)
{
	$ret = "0";
	if (is_array($array))
	{
		foreach ($array as $key=>$sel)
		{
			if (!empty($sel)) $ret++;
		}
	}
	return $ret;
}
//
function IMG_CODE ($code, $type, $DATA, $uid)
{
	return "<IMG border=\"0\" alt=\"Code\" src=\"".URL."/mailid_top.php?uid=".$uid."&amp;".$type."=".$DATA."&amp;mode=img&amp;code=".$code."\">";
}
//
function TRANSLATE_STATUS($status)
{
	switch ($status)
	{
	case "UNCONFIRMED":
		$ret = ACCOUNT_UNCONFIRMED;
		break;

	case "CONFIRMED":
		$ret = ACCOUNT_CONFIRMED;
		break;

	case "LOCKED":
		$ret = ACCOUNT_LOCKED;
		break;

	default:
		$ret = UNKNOWN_STATUS_1.$status.UNKNOWN_STATUS_2;
		break;
	}
	return $ret;
}
//
function GET_LANGUAGE() {
	if (!empty($_GET['mx_lang'])) {
		// Accept only first 2 chars
		$lang = substr($_GET['mx_lang'], 0, 2);
	} else {
		// Do nothing
		$lang = "";
	}

	// Set default return value to default language from config
	$ret = DEFAULT_LANG;

	// Check GET variable and cookie
	if (!empty($lang)) {
		// Check if main language file does exist
		if (file_exists(PATH."inc/language/".$lang.".php")) {
			// Okay found, so let's update cookies
			SET_LANGUAGE($lang);
		}
	} elseif (!isSessionVariableSet('mx_lang')) {
		// Return stored value from cookie
		$ret = get_session('mx_lang');

		// Fixes a warning before the session has the mx_lang constant
		if (empty($ret)) $ret = DEFAULT_LANG;
	}
	return $ret;
}
//
function SET_LANGUAGE($lang) {
	global $_CONFIG;

	// Accept only first 2 chars!
	$lang = substr(SQL_ESCAPE(strip_tags($lang)), 0, 2);

	// Set cookie
	set_session("mx_lang", $lang);
}
//
function LOAD_EMAIL_TEMPLATE($template, $content="", $UID="0") {
	global $DATA, $_CONFIG, $REPLACER;

	// Keept for backward-compatiblity (please replace these variables against our new {--CONST--} syntax!)
	$MAIN_TITLE = MAIN_TITLE; $URL = URL; $WEBMASTER = WEBMASTER;
	$surname = ""; $family = ""; $nick = ""; $sex = 'N';

	// Prepare IP number and User Agent
	$REMOTE_ADDR = getenv('REMOTE_ADDR');
	$HTTP_USER_AGENT  = getenv('HTTP_USER_AGENT');

	$ADMIN = MAIN_TITLE;
	if (isSessionVariableSet('admin_login')) {
		// Load Admin data
		$result = SQL_QUERY_ESC("SELECT email FROM "._MYSQL_PREFIX."_admins WHERE login='%s' LIMIT 1",
			array(SQL_ESCAPE(get_session('admin_login'))), __FILE__, __LINE__);
		list($ADMIN) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);
	}

	// Expiration in a nice output format
	if ($_CONFIG['auto_purge'] == 0) {
		// Will never expire!
		$EXPIRATION = MAIL_WILL_NEVER_EXPIRE;
	} elseif (function_exists('CREATE_FANCY_TIME')) {
		// Create nice date string
		$EXPIRATION = CREATE_FANCY_TIME($_CONFIG['auto_purge']);
	} else {
		// Display days only
		$EXPIRATION = round($_CONFIG['auto_purge']/60/60/24)." "._DAYS;
	}

	switch ($template)
	{
	case "bonus-mail": // Load data for the bonus mail
		$BONUSID    = $DATA[0];
		$content    = $DATA[2];
		$points     = TRANSLATE_COMMA($DATA[4]);
		$TIME       = $DATA[5];
		$TARGET_URL = $DATA[8];
		$CATEGORY   = GET_CATEGORY($DATA[9]);
		$DATA[10]   = $UID;

		// Replace variables
		foreach ($REPLACER as $key=>$value)
		{
			if (isset($DATA[$key])) $content = str_replace($value, $DATA[$key], $content);
		}
		break;

	case "order-admin":
	case "order-member":
		$BLOCKS     = $_CONFIG['max_send'];
		$SUBJECT    = $DATA[0];
		$content    = $DATA[1];
		$PAYMENT    = GET_PAYMENT($DATA[3]);
		$TARGET_URL = $DATA[5];
		$CATEGORY   = GET_CATEGORY($DATA[6]);
		break;

	case "order-reject":
	case "order-deleted":
	case "order-accept":
		$TARGET_URL = $DATA[0];
		$URL        = $DATA[0];
		$SUBJECT    = $DATA[1];
		break;

	case "new-pass":
		$PASS       = $DATA[0];
		$REMOTE     = $DATA[1];
		break;

	case "confirm-member":
		$points     = $_CONFIG['points_register'];
		break;

	case "confirm-referral":
		$PERCENT    = $DATA[0];
		$LEVEL      = $DATA[1];
		$points     = $DATA[2];
		$REFID      = $DATA[3];
		break;

	case "normal-mail":
		$SEND_UID   = $DATA[1];
		$CATEGORY   = GET_CATEGORY($DATA[9]);
		$TIME       = GET_PAY_POINTS($DATA[5], "time");
		$TARGET_URL = $DATA[7];
		$points     = TRANSLATE_COMMA(GET_PAY_POINTS($DATA[5], "payment"));
		// Warning! This ID has changed from 10 to 11!
		$MAILID     = $DATA[11];

		// Replace variables
		foreach ($REPLACER as $key=>$value)
		{
			if (isset($DATA[$key])) $content = str_replace($value, $DATA[$key], $content);
		}
		break;

	case "done-member":
	case "done-admin":
		$SEND_UID   = $DATA[1];
		$CATEGORY   = GET_CATEGORY($DATA[9]);
		$TARGET_URL = $DATA[7];
		break;

	case "back-admin":
	case "back-member":
		$points		= TRANSLATE_COMMA($DATA[10]);
		break;

	case "add-points":
		if (isset($_POST['points'])) {
			$points		= bigintval($_POST['points']);
		} else {
			$points = __POINTS_VALUE;
		}
		break;

	case "guest_request_confirm":
		$HASH       = $DATA[2];
		break;
	}

	// Load user's data
	if ($UID > 0) {
		if (EXT_IS_ACTIVE("nickname")) {
			// Load nickname
			$result = SQL_QUERY_ESC("SELECT surname, family, sex, email, nickname FROM "._MYSQL_PREFIX."_user_data WHERE userid=%d LIMIT 1",
			 array(bigintval($UID)), __FILE__, __LINE__);
			list($surname, $family, $sex, $email, $nick) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);
		} else {
			// Load normal data
			$result = SQL_QUERY_ESC("SELECT surname, family, sex, email FROM "._MYSQL_PREFIX."_user_data WHERE userid=%d LIMIT 1",
			 array(bigintval($UID)), __FILE__, __LINE__);
			list($surname, $family, $sex, $email) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);
			$nick = "---";
		}
	} else {
		// Neutral sex and email address is default
		$sex = 'N';
		$email = WEBMASTER;
	}

	// Translate M to male or F to female
	$salut = TRANSLATE_SEX($sex);

	// Store email for some functions in global data array
	$DATA['email'] = $email;

	// Base directory
	$BASE = PATH."templates/".GET_LANGUAGE()."/emails/";

	// Check for admin/guest/member templates
	if (strpos($template, "admin_") > -1) {
		// Admin template found
		$file = $BASE."admin/".$template.".tpl";
	} elseif (strpos($template, "guest_") > -1) {
		// Guest template found
		$file = $BASE."guest/".$template.".tpl";
	} elseif (strpos($template, "member_") > -1) {
		// Member template found
		$file = $BASE."member/".$template.".tpl";
	} else {
		// Test for extension
		$test = substr($template, 0, strpos($template, "_"));
		if (EXT_IS_ACTIVE($test)) {
			// Set extra path to extension's name
			$file = $BASE.$test."/".$template.".tpl";
		} else {
			// No special filename
			$file = $BASE.$template.".tpl";
		}
	}

	// Does the special template exists?
	if ((!@file_exists($file)) || (!is_readable($file))) {
		// Reset to default template
		$file = $BASE.$template.".tpl";
	}

	// Now does the final template exists?
	if ((@file_exists($file)) && (is_readable($file)))
	{
		// The local file does exists so we load it. :)
		$tmpl_file = @implode("", @file($file));
		$tmpl_file = addslashes($tmpl_file);

		// Compile code
		$tmpl_file = COMPILE_CODE($tmpl_file);

		// Run code
		$tmpl_file = "\$content=\"".$tmpl_file."\";";
		eval($tmpl_file);

		// Replace HTML confirm chars
		$content = html_entity_decode($content);
	}
	 elseif (!empty($template))
	{
		// Template file not found!
		$content = TEMPLATE_404.": ".$template."<br />
".TEMPLATE_CONTENT."
<PRE>".print_r($content, true)."</PRE>
".TEMPLATE_DATA."
<PRE>".print_r($DATA, true)."</PRE>
<br /><br />";

		// Debug mode not active? Then remove the HTML tags
		if (!DEBUG_MODE) $content = strip_tags($content);
	}
	 else
	{
		// No template name supplied!
		$content = NO_TEMPLATE_SUPPLIED;
	}
	return COMPILE_CODE($content);
}
//
function MAKE_TIME($H, $M, $S, $stamp)
{
	// Extract day, month and year from given timestamp
	$DAY   = date("d", $stamp);
	$MONTH = date("m", $stamp);
	$YEAR  = date('Y', $stamp);

	// Create timestamp for wished time which depends on extracted date
	return mktime($H, $M, $S, $MONTH, $DAY, $YEAR);
}
//
function LOAD_URL($URL, $addUrlData=true) {
	global $CSS, $_CONFIG, $link, $db, $footer;

	// Check if http(s):// is there
	if ((substr($URL, 0, 7) != "http://") && (substr($URL, 0, 8) != "https://")) {
		// Make all URLs full-qualified
		$URL = URL."/".$URL;
	}

	// Compile out URI codes
	$URL = COMPILE_CODE($URL);

	// Get output buffer
	$OUTPUT = ob_get_contents();

	// Clear it
	ob_end_clean();

	// Add some data to URL if cookies are not accepted
	if (((!defined('__COOKIES')) || (!__COOKIES)) && ($addUrlData)) $URL = ADD_URL_DATA($URL);

	// Probe for bot from search engine
	if ((eregi("spider", getenv('HTTP_USER_AGENT'))) || (eregi("bot", getenv('HTTP_USER_AGENT'))) || (eregi("spider", getenv('HTTP_USER_AGENT')))) {
		// Search engine bot detected so let's rewrite many chars for the link
		$URL = htmlentities(strip_tags($URL), ENT_QUOTES);

		// Output new location link as anchor
		OUTPUT_HTML("<A href=\"".$URL."\">".$URL."</A>");
	} elseif (!headers_sent()) {
		// Load URL when headers are not sent
		@header ("Location: ".str_replace("&amp;", "&", $URL));
	} else {
		// Output error message
		include(PATH."inc/header.php");
		LOAD_TEMPLATE("redirect_url", false, str_replace("&amp;", "&", $URL));
		include(PATH."inc/footer.php");
	}
	exit();
}
//
function COMPILE_CODE($code, $simple = false, $constants = true, $full = true) {
	global $SEC_CHARS, $URL_CHARS;
	$ARRAY = $SEC_CHARS;

	// Select smaller set of chars to replace when we e.g. want to compile URLs
	if (!$full) $ARRAY = $URL_CHARS;

	// Compile constants
	if ($constants) {
		// BEFORE 0.2.1 : Language and data constants
		// WITH 0.2.1+  : Only language constants
		$code = str_replace('{--', '".', str_replace('--}', '."', $code));

		// BEFORE 0.2.1 : Not used
		// WITH 0.2.1+  : Data constants
		$code = str_replace('{!', '".', str_replace("!}", '."', $code));
	}

	// Compile QUOT and other non-HTML codes
	foreach ($ARRAY['to'] as $k => $to) {
		// Do the reversed thing as in inc/libs/security_functions.php
		$code = str_replace($to, $ARRAY['from'][$k], $code);
	}

	// But shall I keep simple quotes for later use?
	if ($simple) $code = str_replace("\'", '{QUOT}', $code);

	// Find $content[bla][blub] entries
	@preg_match_all('/\$(content|DATA)((\[([a-zA-Z0-9-_]+)\])*)/', $code, $matches);

	// Are some matches found?
	if ((count($matches) > 0) && (count($matches[0]) > 0)) {
		// Replace all matches
		$matchesFound = array();
		foreach ($matches[0] as $key=>$match) {
			// Avoid replacing matches multiple times
			if (!isset($matchesFound[$match])) {
				// Not yet replaced!
				$code = str_replace($match, "\".".$match.".\"", $code);
				$matchesFound[$match] = 1;
			}

			// Take all string elements
			if (("".bigintval($matches[4][$key])."" != $matches[4][$key]) && (!isset($matchesFound[$key."_".$matches[4][$key]]))) {
				// Replace it in the code
				$code = str_replace("[".$matches[4][$key]."]", "['".$matches[4][$key]."']", $code);
				$matchesFound[$key."_".$matches[4][$key]] = 1;
			}
		}
	}

	// Return compiled code
	return $code;
}
//
/************************************************************************
 *                                                                      *
 * Gaenderter Sortier-Algorythmus, $array wird nach dem Array (!)       *
 * $a_sort sortiert:                                                    *
 *                                                                      *
 * $array - Das 3-dimensionale Array, das paralell sortiert werden soll *
 * $a_sort - Array, das die Sortiereihenfolge der ersten Elementeben    *
 * $primary_key - Prim.rschl.ssel aus $a_sort, nach dem sortiert wird   *
 * $order - Sortiereihenfolge: -1 = A-Z, 0 = keine, 1 = Z-A             *
 * $nums - true = Als Zahlen sortieren, false = Als Zeichen sortieren   *
 *                                                                      *
 * $a_sort muss Elemente enthalten, deren Wert Schluessel von $array    *
 * sind... Klingt kompliziert, suchen Sie mal mein Beispiel, dann sehen *
 * Sie, dass es doch nicht so schwer ist! :-)                           *
 *                                                                      *
 ************************************************************************/
function array_pk_sort(&$array, $a_sort, $primary_key = 0, $order = -1, $nums = false)
{
	$dummy = $array;
	while ($primary_key < count($a_sort))
	{
		foreach ($dummy[$a_sort[$primary_key]] as $key=>$value)
		{
			foreach ($dummy[$a_sort[$primary_key]] as $key2=>$value2)
			{
				$match = false;
				if (!$nums)
				{
					// Sort byte-by-byte (also numbers will be interpreted as chars! E.g.: "9" > "10")
					if (($key != $key2) && (strcmp(strtolower($dummy[$a_sort[$primary_key]][$key]), strtolower($dummy[$a_sort[$primary_key]][$key2])) == $order)) $match = true;
				}
				 elseif ($key != $key2)
				{
					// Sort numbers (E.g.: 9 < 10)
					if (($dummy[$a_sort[$primary_key]][$key] < $dummy[$a_sort[$primary_key]][$key2]) && ($order == -1)) $match = true;
					if (($dummy[$a_sort[$primary_key]][$key] > $dummy[$a_sort[$primary_key]][$key2]) && ($order == 1))  $match = true;
				}
				if ($match)
				{
					// We have found two different values, so let's sort whole array
					foreach ($dummy as $sort_key=>$sort_val)
					{
						$t                       = $dummy[$sort_key][$key];
						$dummy[$sort_key][$key]  = $dummy[$sort_key][$key2];
						$dummy[$sort_key][$key2] = $t;
						unset($t);
					}
				}
			}
		}

		// Count one up
		$primary_key++;
	}

	// Write back sorted array
	$array = $dummy;
}
//
function ADD_SELECTION($type, $DEFAULT, $prefix="", $id="0")
{
	global $MONTH_DESCR; $OUT = "";
	if ($type == "yn")
	{
		// This is a yes/no selection only!
		if ($id > 0) $prefix .= "[".$id."]";
		$OUT .= "    <SELECT name=\"".$prefix."\" class=\"register_select\" size=\"1\">\n";
	}
	 else
	{
		// Begin with regular selection box here
		if (!empty($prefix)) $prefix .= "_";
		$type2 = $type;
		if ($id > 0) $type2 .= "[".$id."]";
		$OUT .= "    <SELECT name=\"".strtolower($prefix.$type2)."\" class=\"register_select\" size=\"1\">\n";
	}
	switch ($type)
	{
	case "day": // Day
		for ($idx = 1; $idx < 32; $idx++)
		{
			$OUT .= "      <OPTION value=\"".$idx."\"";
			if ($DEFAULT == $idx) $OUT .= " selected=\"selected\"";
			$OUT .= ">".$idx."</OPTION>\n";
		}
		break;

	case "month": // Month
		foreach ($MONTH_DESCR as $month=>$descr)
		{
			$OUT .= "      <OPTION value=\"".$month."\"";
			if ($DEFAULT == $month) $OUT .= " selected=\"selected\"";
			$OUT .= ">".$descr."</OPTION>\n";
		}
		break;

	case "year": // Year
		// Get current year
		$YEAR = date('Y', time());

		// Check if the default value is larger than minimum and bigger than actual year
		if (($DEFAULT > 1930) && ($DEFAULT >= $YEAR))
		{
			for ($idx = $YEAR; $idx < ($YEAR + 11); $idx++)
			{
				$OUT .= "      <OPTION value=\"".$idx."\"";
				if ($DEFAULT == $idx) $OUT .= " selected=\"selected\"";
				$OUT .= ">".$idx."</OPTION>\n";
			}
		}
		 elseif ($DEFAULT == -1)
		{
			// Current year minus 1
			for ($idx = 2003; $idx <= ($YEAR + 1); $idx++)
			{
				$OUT .= "      <OPTION value=\"".$idx."\">".$idx."</OPTION>\n";
			}
		}
		 else
		{
			// Get current year and subtract 16 (for erotic content)
			$OUT .= "      <OPTION value=\"1929\">&lt;1930</OPTION>\n";
			$YEAR = date('Y', time()) - 16;
			for ($idx = 1930; $idx <= $YEAR; $idx++)
			{
				$OUT .= "      <OPTION value=\"".$idx."\"";
				if ($DEFAULT == $idx) $OUT .= " selected=\"selected\"";
				$OUT .= ">".$idx."</OPTION>\n";
			}
		}
		break;

	case "sec":
	case "min":
		for ($idx = 0; $idx < 60; $idx+=5)
		{
			if (strlen($idx) == 1) $idx = "0".$idx;
			$OUT .= "      <OPTION value=\"".$idx."\"";
			if ($DEFAULT == $idx) $OUT .= " selected=\"selected\"";
			$OUT .= ">".$idx."</OPTION>\n";
		}
		break;

	case "hour":
		for ($idx = 0; $idx < 24; $idx++)
		{
			if (strlen($idx) == 1) $idx = "0".$idx;
			$OUT .= "      <OPTION value=\"".$idx."\"";
			if ($DEFAULT == $idx) $OUT .= " selected=\"selected\"";
			$OUT .= ">".$idx."</OPTION>\n";
		}
		break;

	case "yn":
		$OUT .= "      <OPTION value=\"Y\"";
		if ($DEFAULT == 'Y') $OUT .= " selected=\"selected\"";
		$OUT .= ">".YES."</OPTION>
			<OPTION value=\"N\"";
		if ($DEFAULT == 'N') $OUT .= " selected=\"selected\"";
		$OUT .= ">".NO."</OPTION>\n";
		break;
	}
	$OUT .= "    </SELECT>\n";
	return $OUT;
}
//
function TRANSLATE_YESNO($yn)
{
	switch ($yn)
	{
		case 'Y': $yn = YES; break;
		case 'N': $yn = NO; break;
		default : $yn = "??? (".$yn.")"; break;
	}
	return $yn;
}
//
// Deprecated : $length
// Optional   : $DATA
//
function GEN_RANDOM_CODE($length, $code, $uid, $DATA="")
{
	global $_CONFIG;

	// Build server string
	$server = $_SERVER['PHP_SELF'].":".getenv('HTTP_USER_AGENT').":".getenv('SERVER_SOFTWARE').":".getenv('REMOTE_ADDR').":".":".filemtime(PATH."inc/databases.php");

	// Build key string
	$keys   = SITE_KEY.":".DATE_KEY.":".$_CONFIG['secret_key'].":".$_CONFIG['file_hash'].":".date("d-m-Y (l-F-T)", $_CONFIG['patch_ctime']).":".$_CONFIG['master_salt'];

	// Build string from misc data
	$data   = $code.":".$uid.":".$DATA;

	// Add more additional data
	if (isSessionVariableSet('u_hash'))			$data .= ":".get_session('u_hash');
	if (isset($GLOBALS['userid']))				$data .= ":".$GLOBALS['userid'];
	if (isSessionVariableSet('lifetime'))		$data .= ":".get_session('lifetime');
	if (isSessionVariableSet('mxchange_theme'))	$data .= ":".get_session('mxchange_theme');
	if (isSessionVariableSet('mx_lang'))		$data .= ":".GET_LANGUAGE();
	if (isset($GLOBALS['refid']))				$data .= ":".$GLOBALS['refid'];

	// Calculate number for generating the code
	$a = $code + _ADD - 1;

	// Generate hash with master salt from modula of number with the prime number and other data
	$saltedHash = generateHash(($a % _PRIME).":".$server.":".$keys.":".$data.":".date("d-m-Y (l-F-T)", time()).":".$a, $_CONFIG['master_salt']);

	// Create number from hash
	$rcode = hexdec(substr($saltedHash, strlen($_CONFIG['master_salt']), 9)) / abs(_MAX - $a + sqrt(_ADD)) / pi();

	// At least 10 numbers shall be secure enought!
	$len = $_CONFIG['code_length'];
	if ($len == 0) $len = 10;

	// Cut off requested counts of number
	$return = substr(str_replace('.', "", $rcode), 0, $len);

	// Done building code
	return $return;
}
// Does only allow numbers
function bigintval($num, $castValue = true)
{
	// Filter all numbers out
	$ret = preg_replace("/[^0123456789]/", "", $num);

	// Cast the value?
	if ($castValue) $ret = (int) $ret;

	// Return result
	return $ret;
}
// Insert the code in $img_code into jpeg or PNG image
function GENERATE_IMAGE($img_code, $header=true)
{
	global $_CONFIG;
	if ((strlen($img_code) > 6) || (empty($img_code)) || ($_CONFIG['code_length'] == 0))
	{
		// Stop execution of function here because of over-sized code length
		return;
	}
	 elseif (!$header)
	{
		// Return in an HTML code code
		return "<IMG src=\"".URL."/img.php?code=".$img_code."\">\n";
	}

	switch ($_CONFIG['img_type'])
	{
	case "jpg":
		// Loads JPEG image
		$img = PATH."/theme/".GET_CURR_THEME()."/images/code_bg.jpg";
		if ((file_exists($img)) && (is_readable($img)))
		{
			// Okay, load image and hide all errors
			$image = @imagecreatefromjpeg($img);
		}
		 else
		{
			// Exit function here
			return;
		}
		break;

	case "png":
		// Loads PNG image
		$img = PATH."/theme/".GET_CURR_THEME()."/images/code_bg.png";
		if ((file_exists($img)) && (is_readable($img)))
		{
			// Okay, load image and hide all errors
			$image = @imagecreatefrompng($img);
		}
		 else
		{
			// Exit function here
			return;
		}
		break;
	}

	// Generate text color (red/green/blue; 0 = dark, 255 = bright)
	$text_color = imagecolorallocate($image, 0, 0, 0);

	// Insert code into image
	imagestring($image, 5, 14, 2, $img_code, $text_color);

	// Return to browser
	header ("Content-Type: image/".$_CONFIG['img_type']);

	// Output image with matching image factory
	switch ($_CONFIG['img_type'])
	{
		case "jpg": imagejpeg($image); break;
		case "png": imagepng($image);  break;
	}

	// Remove image from memory
	imagedestroy($image);
}
function CREATE_TIME_SELECTIONS($timestamp, $prefix="", $display="", $align="center", $return_array=false)
{
	// Calculate 15-seconds timestamp (15-seconds-steps shall be fine ;) )
	$timestamp = round($timestamp / 15) * 15;
	// Do we have a leap year?
	$SWITCH = 0;
	$TEST = date('Y', time()) / 4;
	$M1 = date("m", time());
	$M2 = date("m", (time() + $timestamp));
	// If so and if current time is before 02/29 and estimated time is after 02/29 then add 86400 seconds (one day)
	if ((floor($TEST) == $TEST) && ($M1 == "02") && ($M2 > "02"))  $SWITCH = ONE_DAY;
	// First of all years...
	$Y = abs(floor($timestamp / (31536000 + $SWITCH)));
	// Next months...
	$M = abs(floor($timestamp / 2628000 - $Y * 12));
	// Next weeks
	$W = abs(floor($timestamp / 604800 - $Y * ((365 + $SWITCH / ONE_DAY) / 7) - ($M / 12 * (365 + $SWITCH / ONE_DAY) / 7)));
	// Next days...
	$D = abs(floor($timestamp / 86400 - $Y * (365 + $SWITCH / ONE_DAY) - ($M / 12 * (365 + $SWITCH / ONE_DAY)) - $W * 7));
	// Next hours...
	$h = abs(floor($timestamp / 3600 - $Y * (365 + $SWITCH / ONE_DAY) * 24 - ($M / 12 * (365 + $SWITCH / ONE_DAY) * 24) - $W * 7 * 24 - $D * 24));
	// Next minutes..
	$m = abs(floor($timestamp / 60 - $Y * (365 + $SWITCH / ONE_DAY) * 24 * 60 - ($M / 12 * (365 + $SWITCH / ONE_DAY) * 24 * 60) - $W * 7 * 24 * 60 - $D * 24 * 60 - $h * 60));
	// And at last seconds...
	$s = abs(floor($timestamp - $Y * (365 + $SWITCH / ONE_DAY) * 24 * 3600 - ($M / 12 * (365 + $SWITCH / ONE_DAY) * 24 * 3600) - $W * 7 * 24 * 3600 - $D * 24 * 3600 - $h * 3600 - $m * 60));
	//
	// Now we convert them in seconds...
	//
	if ($return_array)
	{
		// Just put all data in an array for later use
		$OUT = array(
			'YEARS'   => $Y,
			'MONTHS'  => $M,
			'WEEKS'   => $W,
			'DAYS'    => $D,
			'HOURS'   => $h,
			'MINUTES' => $m,
			'SECONDS' => $s
		);
	}
	 else
	{
		// Generate table
		$OUT  = "<DIV align=\"".$align."\">\n";
		$OUT .= "<TABLE border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"admin_table dashed\">\n";
		$OUT .= "<TR>\n";
		if (ereg('Y', $display) || (empty($display)))
		{
			$OUT .= "  <TD align=\"center\" class=\"admin_title bottom\"><STRONG class=\"tiny\">"._YEARS."</STRONG></TD>\n";
		}
		if (ereg("M", $display) || (empty($display)))
		{
			$OUT .= "  <TD align=\"center\" class=\"admin_title bottom\"><STRONG class=\"tiny\">"._MONTHS."</STRONG></TD>\n";
		}
		if (ereg("W", $display) || (empty($display)))
		{
			$OUT .= "  <TD align=\"center\" class=\"admin_title bottom\"><STRONG class=\"tiny\">"._WEEKS."</STRONG></TD>\n";
		}
		if (ereg("D", $display) || (empty($display)))
		{
			$OUT .= "  <TD align=\"center\" class=\"admin_title bottom\"><STRONG class=\"tiny\">"._DAYS."</STRONG></TD>\n";
		}
		if (ereg("h", $display) || (empty($display)))
		{
			$OUT .= "  <TD align=\"center\" class=\"admin_title bottom\"><STRONG class=\"tiny\">"._HOURS."</STRONG></TD>\n";
		}
		if (ereg("m", $display) || (empty($display)))
		{
			$OUT .= "  <TD align=\"center\" class=\"admin_title bottom\"><STRONG class=\"tiny\">"._MINUTES."</STRONG></TD>\n";
		}
		if (ereg("s", $display) || (empty($display)))
		{
			$OUT .= "  <TD align=\"center\" class=\"admin_title bottom\"><STRONG class=\"tiny\">".SECS."</STRONG></TD>\n";
		}
		$OUT .= "</TR>\n";
		$OUT .= "<TR>\n";
		if (ereg('Y', $display) || (empty($display)))
		{
			// Generate year selection
			$OUT .= "  <TD align=\"center\"><SELECT class=\"mini_select\" name=\"".$prefix."_ye\" size=\"1\">\n";
			for ($idx = 0; $idx <= 10; $idx++)
			{
				$OUT .= "    <OPTION class=\"mini_select\" value=\"".$idx."\"";
				if ($idx == $Y) $OUT .= " selected default";
				$OUT .= ">".$idx."</OPTION>\n";
			}
			$OUT .= "  </SELECT></TD>\n";
		}
		 else
		{
			$OUT .= "<INPUT type=\"hidden\" name=\"".$prefix."_ye\" value=\"0\">\n";
		}
		if (ereg("M", $display) || (empty($display)))
		{
			// Generate month selection
			$OUT .= "  <TD align=\"center\"><SELECT class=\"mini_select\" name=\"".$prefix."_mo\" size=\"1\">\n";
			for ($idx = 0; $idx <= 11; $idx++)
			{
					$OUT .= "  <OPTION class=\"mini_select\" value=\"".$idx."\"";
				if ($idx == $M) $OUT .= " selected default";
				$OUT .= ">".$idx."</OPTION>\n";
			}
			$OUT .= "  </SELECT></TD>\n";
		}
		 else
		{
			$OUT .= "<INPUT type=\"hidden\" name=\"".$prefix."_mo\" value=\"0\">\n";
		}
		if (ereg("W", $display) || (empty($display)))
		{
			// Generate week selection
			$OUT .= "  <TD align=\"center\"><SELECT class=\"mini_select\" name=\"".$prefix."_we\" size=\"1\">\n";
			for ($idx = 0; $idx <= 4; $idx++)
			{
				$OUT .= "  <OPTION class=\"mini_select\" value=\"".$idx."\"";
				if ($idx == $W) $OUT .= " selected default";
				$OUT .= ">".$idx."</OPTION>\n";
			}
			$OUT .= "  </SELECT></TD>\n";
		}
		 else
		{
			$OUT .= "<INPUT type=\"hidden\" name=\"".$prefix."_we\" value=\"0\">\n";
		}
		if (ereg("D", $display) || (empty($display)))
		{
			// Generate day selection
			$OUT .= "  <TD align=\"center\"><SELECT class=\"mini_select\" name=\"".$prefix."_da\" size=\"1\">\n";
			for ($idx = 0; $idx <= 31; $idx++)
			{
				$OUT .= "  <OPTION class=\"mini_select\" value=\"".$idx."\"";
				if ($idx == $D) $OUT .= " selected default";
				$OUT .= ">".$idx."</OPTION>\n";
			}
			$OUT .= "  </SELECT></TD>\n";
		}
		 else
		{
			$OUT .= "<INPUT type=\"hidden\" name=\"".$prefix."_da\" value=\"0\">\n";
		}
		if (ereg("h", $display) || (empty($display)))
		{
			// Generate hour selection
			$OUT .= "  <TD align=\"center\"><SELECT class=\"mini_select\" name=\"".$prefix."_ho\" size=\"1\">\n";
			for ($idx = 0; $idx <= 23; $idx++)
			{
				$OUT .= "  <OPTION class=\"mini_select\" value=\"".$idx."\"";
				if ($idx == $h) $OUT .= " selected default";
				$OUT .= ">".$idx."</OPTION>\n";
			}
			$OUT .= "  </SELECT></TD>\n";
		}
		 else
		{
			$OUT .= "<INPUT type=\"hidden\" name=\"".$prefix."_ho\" value=\"0\">\n";
		}
		if (ereg("m", $display) || (empty($display)))
		{
			// Generate minute selection
			$OUT .= "  <TD align=\"center\"><SELECT class=\"mini_select\" name=\"".$prefix."_mi\" size=\"1\">\n";
			for ($idx = 0; $idx <= 59; $idx++)
			{
				$OUT .= "  <OPTION class=\"mini_select\" value=\"".$idx."\"";
				if ($idx == $m) $OUT .= " selected default";
				$OUT .= ">".$idx."</OPTION>\n";
			}
			$OUT .= "  </SELECT></TD>\n";
		}
		 else
		{
			$OUT .= "<INPUT type=\"hidden\" name=\"".$prefix."_mi\" value=\"0\">\n";
		}
		if (ereg("s", $display) || (empty($display)))
		{
			// Generate second selection
			$OUT .= "  <TD align=\"center\"><SELECT class=\"mini_select\" name=\"".$prefix."_se\" size=\"1\">\n";
			for ($idx = 0; $idx <= 45; $idx+=15)
			{
				$OUT .= "  <OPTION class=\"mini_select\" value=\"".$idx."\"";
				if ($idx == $s) $OUT .= " selected default";
				$OUT .= ">".$idx."</OPTION>\n";
			}
			$OUT .= "  </SELECT></TD>\n";
		}
		 else
		{
			$OUT .= "<INPUT type=\"hidden\" name=\"".$prefix."_se\" value=\"0\">\n";
		}
		$OUT .= "</TR>\n";
		$OUT .= "</TABLE>\n";
		$OUT .= "</DIV>\n";
		// Return generated HTML code
	}
	return $OUT;
}
//
function CREATE_TIMESTAMP_FROM_SELECTIONS($prefix, $POST) {
	$ret = "0";
	// Do we have a leap year?
	$SWITCH = 0;
	$TEST = date('Y', time()) / 4;
	$M1   = date("m", time());
	// If so and if current time is before 02/29 and estimated time is after 02/29 then add 86400 seconds (one day)
	if ((floor($TEST) == $TEST) && ($M1 == "02") && ($POST[$prefix."_mo"] > "02"))  $SWITCH = ONE_DAY;
	// First add years...
	$ret += $POST[$prefix."_ye"] * (31536000 + $SWITCH);
	// Next months...
	$ret += $POST[$prefix."_mo"] * 2628000;
	// Next weeks
	$ret += $POST[$prefix."_we"] * 604800;
	// Next days...
	$ret += $POST[$prefix."_da"] * 86400;
	// Next hours...
	$ret += $POST[$prefix."_ho"] * 3600;
	// Next minutes..
	$ret += $POST[$prefix."_mi"] * 60;
	// And at last seconds...
	$ret += $POST[$prefix."_se"];
	// Return calculated value
	return $ret;
}
// Sends out mail to all administrators
function SEND_ADMIN_EMAILS_PRO($subj, $template, $content="", $UID="0") {
	// Trim template name
	$template = trim($template);

	// Load email template
	$msg = LOAD_EMAIL_TEMPLATE($template, $content, $UID);

	if (GET_EXT_VERSION("admins") < "0.4.0") {
		// Older version detected!
		return SEND_ADMIN_EMAILS($subj, $msg);
	}

	// Check which admin shall receive this mail
	$result = SQL_QUERY_ESC("SELECT DISTINCT admin_id FROM "._MYSQL_PREFIX."_admins_mails WHERE mail_template='%s' ORDER BY admin_id",
	 array($template), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 0) {
		// Create new entry (to all admins)
		$result = SQL_QUERY_ESC("INSERT INTO "._MYSQL_PREFIX."_admins_mails (admin_id, mail_template) VALUES (0, '%s')",
		 array($template), __FILE__, __LINE__);
	} else {
		// Load admin IDs...
		$aids = array();
		while(list($aid) = SQL_FETCHROW($result)) {
			$aids[] = $aid;
		}

		// Free memory
		SQL_FREERESULT($result);

		// "implode" IDs and query string
		$aid = implode(",", $aids);
		if ($aid == "-1") {
			// Add line to userlog
			USERLOG_ADD_LINE($subj, $msg, $UID);
			return;
		} elseif ($aid == "0") {
			// Select all email adresses
			$result = SQL_QUERY("SELECT email FROM "._MYSQL_PREFIX."_admins ORDER BY id", __FILE__, __LINE__);
		} else {
			// If Admin-ID is not "to-all" select
			$result = SQL_QUERY_ESC("SELECT email FROM "._MYSQL_PREFIX."_admins WHERE id IN (%s) ORDER BY id", array($aid), __FILE__, __LINE__);
		}
	}

	// Load email addresses and send away
	while (list($email) = SQL_FETCHROW($result)) {
		SEND_EMAIL($email, $subj, $msg);
	}

	// Free memory
	SQL_FREERESULT($result);
}
//
function CREATE_FANCY_TIME($stamp) {
	// Get data array with years/months/weeks/days/...
	$data = CREATE_TIME_SELECTIONS($stamp, "", "", "", true);
	$ret = "";
	foreach($data as $k=>$v) {
		if ($v > 0) {
			// Value is greater than 0 "eval" data to return string
			$eval = "\$ret .= \", \".\$v.\" \"._".strtoupper($k).";";
			eval($eval);
			break;
		}
	}

	// Remove first "comma,null" string
	$ret = substr($ret, 2);
	return $ret;
}
//
function ADD_EMAIL_NAV($PAGES, $offset, $show_form, $colspan, $return=false) {
	$SEP = ""; $TOP = "";
	if (!$show_form) {
		$TOP = " top2";
		$SEP = "<TR><TD colspan=\"".$colspan."\" class=\"seperator\">&nbsp;</TD></TR>";
	}

	$NAV = "";
	for ($page = 1; $page <= $PAGES; $page++) {
		// Is the page currently selected or shall we generate a link to it?
		if (($page == $_GET['page']) || ((empty($_GET['page'])) && ($page == "1"))) {
			// Is currently selected, so only highlight it
			$NAV .= "<STRONG>-";
		} else {
			// Open anchor tag and add base URL
			$NAV .= "<A href=\"".URL."/modules.php?module=admin&amp;what=".$GLOBALS['what']."&amp;page=".$page."&amp;offset=".$offset;

			// Add userid when we shall show all mails from a single member
			if ((isset($_GET['u_id'])) && (bigintval($_GET['u_id']) > 0)) $NAV .= "&amp;u_id=".bigintval($_GET['u_id']);

			// Close open anchor tag
			$NAV .= "\">";
		}
		$NAV .= $page;
		if (($page == $_GET['page']) || ((empty($_GET['page'])) && ($page == "1"))) {
			// Is currently selected, so only highlight it
			$NAV .= "-</STRONG>";
		} else {
			// Close anchor tag
			$NAV .= "</A>";
		}

		// Add seperator if we have not yet reached total pages
		if ($page < $PAGES) $NAV .= "&nbsp;|&nbsp;";
	}

	// Define constants only once
	if (!defined('__NAV_OUTPUT')) {
		define('__NAV_OUTPUT' , $NAV);
		define('__NAV_COLSPAN', $colspan);
		define('__NAV_TOP'    , $TOP);
		define('__NAV_SEP'    , $SEP);
	}

	// Load navigation template
	$OUT = LOAD_TEMPLATE("admin_email_nav_row", true);

	if ($return) {
		// Return generated HTML-Code
		return $OUT;
	} else {
		// Output HTML-Code
		OUTPUT_HTML($OUT);
	}
}

//
function MXCHANGE_OPEN ($script) {
	//* DEBUG */ print("SCRIPT=".$script."<br />\n");
	// Compile the script name
	$script = COMPILE_CODE($script);
	//* DEBUG */ print("SCRIPT=".$script."<br />\n");

	// Use default SERVER_URL by default... ;) So?
	$url = SERVER_URL;
	if (substr($script, 0, 7) == "http://") {
		// Use the hostname from script URL as new hostname
		$url = substr($script, 7);
		$extract = explode("/", $url);
		$url = $extract[0];
		// Done extracting the URL :)
	}

	// Extract host name
	$host = str_replace("http://", "", $url);
	if (ereg("/", $host)) $host = substr($host, 0, strpos($host, "/"));

	// Generate relative URL
	//* DEBUG */ print("SCRIPT=".$script."<br />\n");
	if (substr(strtolower($script), 0, 7) == "http://") {
		// But only if http:// is in front!
		$script = substr($script, (strlen($url) + 7));
	} elseif (substr(strtolower($script), 0, 8) == "https://") {
		// Does this work?!
		$script = substr($script, (strlen($url) + 8));
	}

	//* DEBUG */ print("SCRIPT=".$script."<br />\n");
	if (substr($script, 0, 1) == "/") $script = substr($script, 1);

	// Open connection
	//* DEBUG */ die("SCRIPT=".$script."<br />\n");
	$fp = @fsockopen($host, 80, $errno, $errdesc, 30);
	if (!$fp) {
		// Failed!
		return array("", "", "");
	}

	// Generate request header
	$request  = "GET /".trim($script)." HTTP/1.0\r\n";
	$request .= "Host: ".$host."\r\n";
	$request .= "Referer: ".URL."/admin.php\r\n";
	$request .= "User-Agent: ".TITLE."/".FULL_VERSION."\r\n\r\n";

	// Initialize array
	$response = array();

	// Write request
	fputs($fp, $request);

	// Read response
	while(!feof($fp)) {
		$response[] = trim(fgets($fp, 1024));
	}

	// Close socket
	fclose($fp);

	// Was the request successfull?
	if ((!ereg("200 OK", $response[0])) && (empty($response[0]))) {
		// Not found / access forbidden
		$response = array("", "", "");
	}

	// Return response
	return $response;
}
// Taken from www.php.net eregi() user comments
function VALIDATE_EMAIL($email) {
	// Compile email
	$email = COMPILE_CODE($email);

	// Check first part of email address
	$first = "[-a-z0-9!#$%&\'*+/=?^_<{|}~]+(\.[-a-zA-Z0-9!#$%&\'*+/=?^_<{|}~]+)*";

	//  Check domain
	$domain = "[a-z0-9-]+(\.[a-z0-9-]{2,5})+";

	// Generate pattern
	$regex = "^".$first."@".$domain."$";

	// Return check result
	return eregi($regex, $email);
}
// Function taken from user comments on www.php.net / function eregi()
function VALIDATE_URL ($URL, $compile=true) {
	// Trim URL a little
	$URL = trim(urldecode($URL));
	//* DEBUG: */ echo $URL."<br />";

	// Compile some chars out...
	if ($compile) $URL = COMPILE_CODE($URL, false, false, false);
	//* DEBUG: */ echo $URL."<br />";

	// Check for the extension filter
	if (EXT_IS_ACTIVE("filter")) {
		// Use the extension's filter set
		return FILTER_VALIDATE_URL($URL, false);
	}

	// If not installed, perform a simple test. Just make it sure there is always a http:// or
	// https:// in front of the URLs
	return (((substr($URL, 0, 7) == "http://") || (substr($URL, 0, 8) == "https://")) && (strlen($URL) >= 12));
}
//
function MEMBER_ACTION_LINKS($uid, $status="") {
	// Define all main targets
	$TARGETS = array("del_user", "edit_user", "lock_user", "add_points", "sub_points");

	// Begin of navigation links
	$eval = "\$OUT = \"[&nbsp;";

	foreach ($TARGETS as $tar) {
		$eval .= "<SPAN class=\\\"admin_user_link\\\"><A href=\\\"".URL."/modules.php?module=admin&amp;what=".$tar."&amp;u_id=".$uid."\\\" title=\\\"\".ADMIN_LINK_";
		//* DEBUG: */ echo "*".$tar."/".$status."*<br />\n";
		if (($tar == "lock_user") && ($status == "LOCKED")) {
			// Locked accounts shall be unlocked
			$eval .= "UNLOCK_USER";
		} else {
			// All other status is fine
			$eval .= strtoupper($tar);
		}
		$eval .= "_TITLE.\"\\\">\".ADMIN_";
		if (($tar == "lock_user") && ($status == "LOCKED")) {
			// Locked accounts shall be unlocked
			$eval .= "UNLOCK_USER";
		} else {
			// All other status is fine
			$eval .= strtoupper($tar);
		}
		$eval .= ".\"</A></SPAN>&nbsp;|&nbsp;";
	}

	// Finish navigation link
	$eval = substr($eval, 0, -7) . "]\";";
	eval($eval);

	// Return string
	return $OUT;
}
// Function for backward-compatiblity
function ADD_CATEGORY_TABLE ($MODE, $return=false) {
	// Load it from the register extension
	return REGISTER_ADD_CATEGORY_TABLE ($MODE, $return);
}
// Generate an email link
function CREATE_EMAIL_LINK($email, $table="admins") {
	// Default email link (INSECURE! Spammer can read this by harvester programs)
	$EMAIL = "mailto:".$email;

	// Check for several extensions
	if ((EXT_IS_ACTIVE("admins")) && ($table == "admins")) {
		// Create email link for contacting admin in guest area
		$EMAIL = ADMINS_CREATE_EMAIL_LINK($email);
	} elseif ((EXT_IS_ACTIVE("user", true)) && (GET_EXT_VERSION("user") >= "0.3.3") && ($table == "user_data")) {
		// Create email link for contacting a member within admin area (or later in other areas, too?)
		$EMAIL = USER_CREATE_EMAIL_LINK($email);
	} elseif ((EXT_IS_ACTIVE("sponsor")) && ($table == "sponsor_data")) {
		// Create email link to contact sponsor within admin area (or like the link above?)
		$EMAIL = SPONSOR_CREATE_EMAIL_LINK($email);
	}

	// Shall I close the link when there is no admin?
	if ((!IS_ADMIN()) && ($EMAIL == $email)) $EMAIL = "#"; // Closed!

	// Return email link
	return $EMAIL;
}
// Generate a hash for extra-security for all passwords
function generateHash ($plainText, $salt = "") {
	global $_CONFIG, $_SERVER;

	// Is the required extension "sql_patches" there?
	if ((GET_EXT_VERSION("sql_patches") < "0.3.6") || (GET_EXT_VERSION("sql_patches") == "")) {
		// Extension sql_patches is missing/outdated so we return the plain text
		return $plainText;
	}

	// When the salt is empty build a new one, else use the first x configured characters as the salt
	if ($salt == "") {
		// Build server string
		$server = $_SERVER['PHP_SELF'].":".getenv('HTTP_USER_AGENT').":".getenv('SERVER_SOFTWARE').":".getenv('REMOTE_ADDR').":".":".filemtime(PATH."inc/databases.php");

		// Build key string
		$keys   = SITE_KEY.":".DATE_KEY.":".$_CONFIG['secret_key'].":".$_CONFIG['file_hash'].":".date("d-m-Y (l-F-T)", $_CONFIG['patch_ctime']).":".$_CONFIG['master_salt'];

		// Additional data
		$data = $plainText.":".uniqid(rand(), true).":".time();

		// Calculate number for generating the code
		$a = time() + _ADD - 1;

		// Generate SHA1 sum from modula of number and the prime number
		$sha1 = sha1(($a % _PRIME).$server.":".$keys.":".$data.":".date("d-m-Y (l-F-T)", time()).":".$a);
		//* DEBUG: */ echo "SHA1=".$sha1." (".strlen($sha1).")<br>";
		$sha1 = scrambleString($sha1);
		//* DEBUG: */ echo "Scrambled=".$sha1." (".strlen($sha1).")<br>";
		//* DEBUG: */ $sha1b = descrambleString($sha1);
		//* DEBUG: */ echo "Descrambled=".$sha1b." (".strlen($sha1b).")<br>";

		// Generate the password salt string
		$salt = substr($sha1, 0, $_CONFIG['salt_length']);
		//* DEBUG: */ echo $salt." (".strlen($salt).")<br />";
	}
	 else
	{
		$salt = substr($salt, 0, $_CONFIG['salt_length']);
	}

	// Return hash
	return $salt . sha1($salt . $plainText);
}
//
function scrambleString($str) {
	global $_CONFIG;

	// Init
	$scrambled = "";

	// Final check, in case of failture it will return unscrambled string
	if (strlen($str) > 40) {
		// The string is to long
		return $str;
	} elseif (strlen($str) == 40) {
		// From database
		$scrambleNums = explode(":", $_CONFIG['pass_scramble']);
	} else {
		// Generate new numbers
		$scrambleNums = explode(":", genScrambleString(strlen($str)));
	}

	// Scramble string here
	//* DEBUG: */ echo "***Original=".$str."***<br />";
	for ($idx = 0; $idx < strlen($str); $idx++) {
		// Get char on scrambled position
		$char = substr($str, $scrambleNums[$idx], 1);

		// Add it to final output string
		$scrambled .= $char;
	}

	// Return scrambled string
	//* DEBUG: */ echo "***Scrambled=".$scrambled."***<br />";
	return $scrambled;
}
//
function descrambleString($str)
{
	global $_CONFIG;
	// Scramble only 40 chars long strings
	if (strlen($str) != 40) return $str;

	// Load numbers from config
	$scrambleNums = explode(":", $_CONFIG['pass_scramble']);

	// Validate numbers
	if (count($scrambleNums) != 40) return $str;

	// Begin descrambling
	$orig = str_repeat(" ", 40);
	//* DEBUG: */ echo "+++Scrambled=".$str."+++<br />";
	for ($idx = 0; $idx < 40; $idx++)
	{
		$char = substr($str, $idx, 1);
		$orig = substr_replace($orig, $char, $scrambleNums[$idx], 1);
	}

	// Return scrambled string
	//* DEBUG: */ echo "+++Original=".$orig."+++<br />";
	return $orig;
}
//
function genScrambleString($len) {
	// Prepare randomizer and array for the numbers
	mt_srand((double) microtime() * 1000000);
	$scrambleNumbers = array();

	// First we need to setup randomized numbers from 0 to 31
	for ($idx = 0; $idx < $len; $idx++) {
		// Generate number
		$rand = mt_rand(0, ($len -1));

		// Check for it by creating more numbers
		while (array_key_exists($rand, $scrambleNumbers)) {
			$rand = mt_rand(0, ($len -1));
		}

		// Add number
		$scrambleNumbers[$rand] = $rand;
	}

	// So let's create the string for storing it in database
	$scrambleString = implode(":", $scrambleNumbers);
	return $scrambleString;
}
// Append data like session ID referral ID to the given URL which would
// normally be stored in cookies
function ADD_URL_DATA($URL)
{
	global $_CONFIG;
	$ADD = "";

	// Determine URL binder
	$BIND = "?";
	if (strpos($URL, "?") !== false) $BIND = "&";

	if ((!defined('__COOKIES')) || ((!__COOKIES))) {
		// Cookies are not accepted
		if ((!empty($_GET['refid'])) && (strpos($URL, "refid=") == 0)) {
			// Cookie found in URL
			$ADD .= $BIND."refid=".bigintval($_GET['refid']);
		} elseif ((GET_EXT_VERSION("sql_patches") != '') && ($_CONFIG['def_refid'] > 0)) {
			// Not found! So let's set default here
			$ADD .= $BIND."refid=".$_CONFIG['def_refid'];
		}

		// Is there already added data? Then change the binder
		if (!empty($ADD)) $BIND = "&";

		// Add session ID
		if ((!empty($_GET['PHPSESSID'])) && (strpos($URL, "PHPSESSID=") == 0)) {
			// Add session from URL
			$ADD .= $BIND."PHPSESSID=".SQL_ESCAPE(strip_tags($_GET['PHPSESSID']));
		} else {
			// Add current session
			$ADD .= $BIND."PHPSESSID=".session_id();
		}
	}

	// Add all together and return it
	return $URL.$ADD;
}
//
function generatePassString($passHash) {
	global $_CONFIG;

	// Return vanilla password hash
	$ret = $passHash;

	// Is a secret key and master salt already initialized?
	if ((!empty($_CONFIG['secret_key'])) && (!empty($_CONFIG['master_salt']))) {
		// Only calculate when the secret key is generated
		$newHash = ""; $start = 9;
		for ($idx = 0; $idx < 10; $idx++) {
			$part1 = hexdec(substr($passHash, $start, 4));
			$part2 = hexdec(substr($_CONFIG['secret_key'], $start, 4));
			$mod = dechex($idx);
			if ($part1 > $part2) {
				$mod = dechex(sqrt(($part1 - $part2) * _PRIME / pi()));
			} elseif ($part2 > $part1) {
				$mod = dechex(sqrt(($part2 - $part1) * _PRIME / pi()));
			}
			$mod = substr(round($mod), 0, 4);
			$mod = str_repeat('0', 4-strlen($mod)).$mod;
			//* DEBUG: */ echo "*".$start."=".$mod."*<br>";
			$start += 4;
			$newHash .= $mod;
		}

		//* DEBUG: */ die($passHash."<br>".$newHash." (".strlen($newHash).")");
		$ret = generateHash($newHash, $_CONFIG['master_salt']);
	} else {
		// Hash it simple
		//* DEBUG: */ echo "--".$passHash."--<br />\n";
		$ret = md5($passHash);
		//* DEBUG: */ echo "++".$ret."++<br />\n";
	}

	// Return result
	return $ret;
}
// Fix "deleted" cookies
function FIX_DELETED_COOKIES ($cookies) {
	// Is this an array with entries?
	if ((is_array($cookies)) && (count($cookies) > 0)) {
		// Then check all cookies if they are marked as deleted!
		foreach ($cookies as $cookieName) {
			// Is the cookie set to "deleted"?
			if (get_session($cookieName) == "deleted") {
				set_session($cookieName, "");
			}
		}
	}
}
// Output error messages in a fasioned way and die...
function mxchange_die ($msg) {
	global $footer;

	// Load the message template
	LOAD_TEMPLATE("admin_settings_saved", false, $msg);

	// Load footer
	include(PATH."inc/footer.php");

	// Exit explicitly
	exit;
}

// Display parsing time and number of SQL queries in footer
function DISPLAY_PARSING_TIME_FOOTER() {
	global $startTime, $_CONFIG;
	$endTime = microtime(true);

	// Is the timer started?
	if (!isset($GLOBALS['startTime'])) {
		// Abort here
		return false;
	}

	// "Explode" both times
	$start = explode(" ", $GLOBALS['startTime']);
	$end = explode(" ", $endTime);
	$runTime = $end[0] - $start[0];
	if ($runTime < 0) $runTime = 0;
	$runTime = TRANSLATE_COMMA($runTime);

	// Prepare output
	$content = array(
		'runtime' 		=> $runTime,
		'numSQLs'		=> ($_CONFIG['sql_count'] + 1),
		'numTemplates'	=> ($_CONFIG['num_templates'] + 1)
	);

	// Load the template
	LOAD_TEMPLATE("show_timings", false, $content);
}

// Unset/set session variables
function set_session ($var, $value) {
	global $CSS;
	// Abort in CSS mode here
	if ($CSS == 1) return true;

	// Trim value and session variable
	$var = trim(SQL_ESCAPE($var)); $value = trim($value);

	// Is the session variable set?
	if (("".$value."" == "") && (isSessionVariableSet($var))) {
		// Remove the session
		//* DEBUG: */ echo "UNSET:".$var."=".get_session($var)."<br />\n";
		unset($_SESSION[$var]);
		return session_unregister($var);
	} elseif (("".$value."" != '') && (!isSessionVariableSet($var))) {
		// Set session
		//* DEBUG: */ echo "SET:".$var."=".$value."<br />\n";
		$_SESSION[$var] =  $value;
		return session_register($var);
	}

	// Return always true if the session variable is already set.
	// Keept me busy for a longer while...
	//* DEBUG: */ echo "IGNORED:".$var."=".$value."<br />\n";
	return true;
}
// Check wether a boolean constant is set
// Taken from user comments in PHP documentation for function constant()
function isBooleanConstantAndTrue($constname) { // : Boolean
	$res = false;
	if (defined($constname)) $res = (constant($constname) === true);
	return($res);
}

// Check wether a session variable is set
function isSessionVariableSet($var) {
	return (isset($_SESSION[$var]));
}

// Returns wether the value of the session variable or NULL if not set
function get_session($var) {
	if (!isset($_SESSION)) session_start();

	// Default is not found! ;-)
	$value = null;

	// Is the variable there?
	if (isSessionVariableSet($var)) {
		// Then  get it secured!
		$value = SQL_ESCAPE($_SESSION[$var]);
	}

	// Return the value
	return $value;
}

//
//////////////////////////////////////////////
//                                          //
// AUTOMATICALLY RE-GNERATED FUNCTIONS ONLY //
//                                          //
//////////////////////////////////////////////
//
if (!function_exists('html_entity_decode'))
{
	// Taken from documentation on www.php.net
	function html_entity_decode($string)
	{
		$trans_tbl = get_html_translation_table(HTML_ENTITIES);
		$trans_tbl = array_flip($trans_tbl);
		return strtr($string, $trans_tbl);
	}
}
//
?>
