<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 12/26/2007 *
 * ================                             Last change: 12/26/2007 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_wernis.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Configure wernis sub-system                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auszahlungensarten editieren                     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!IS_ADMIN()))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}
// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

if (isset($_POST['ok'])) {
	// First merge temporarily the new API data into the current config
	$_CONFIG = array_merge($_CONFIG, $_POST);

	// Let's test the API first (hold your horses here, cowboy! Thanks. :) )
	if (WERNIS_TEST_API()) {
		// Save settings
		ADMIN_SAVE_SETTINGS($_POST);
	} else {
		// Failed to test the API!
		LOAD_TEMPLATE("admin_settings_saved", false, GET_WERNIS_ERROR_MESSAGE());
	}
}  else {
	// Prepare data for template output
	$content = array(
		'min_payout'	=> bigintval($_CONFIG['wernis_min_payout']),
		'min_withdraw'	=> bigintval($_CONFIG['wernis_min_withdraw']),
		'api_id'		=> bigintval($_CONFIG['wernis_api_id']),
		'api_md5'		=> $_CONFIG['wernis_api_md5'],
		'api_url'		=> $_CONFIG['wernis_api_url'],
		'refid'			=> bigintval($_CONFIG['wernis_refid'])
	);

	// Load template
	LOAD_TEMPLATE("admin_config_wernis", false, $content);
}

//
?>
